import { NgModule, Injector } from '@angular/core';
import { FirebaseAuth } from './firebase-auth.service';
import { FirebaseDatabase } from './firebase-database.service';
import { FirebaseApp } from './firebase-app.service';
/** @internal */
var lazyInvocation = true;
export function invokeLazy() {
    return lazyInvocation;
}
function setLazyInvocation(lazy) {
    lazyInvocation = lazy;
}
export var FirebaseModule = (function () {
    function FirebaseModule() {
    }
    FirebaseModule.forRoot = function (config, lazyInvocation) {
        if (lazyInvocation === void 0) { lazyInvocation = true; }
        this.validateConfig(config);
        setLazyInvocation(lazyInvocation);
        return {
            ngModule: FirebaseModule,
            providers: this.getProviders(config)
        };
    };
    FirebaseModule.validateConfig = function (config) {
        var defaultApps = config.filter(function (config) { return !config.token; });
        if (defaultApps.length > 1) {
            throw new Error('There can only be one default Firebase App');
        }
    };
    FirebaseModule.getProviders = function (config) {
        var defaultApp = config.filter(function (config) { return !config.token; })[0];
        var additionalApps = config.filter(function (config) { return !!config.token; });
        return [
            {
                provide: FirebaseApp,
                useFactory: function (injector) { return new FirebaseApp(defaultApp, injector); },
                deps: [Injector]
            },
            {
                provide: FirebaseAuth,
                useFactory: function (firebaseApp) { return firebaseApp.auth(); },
                deps: [FirebaseApp]
            },
            {
                provide: FirebaseDatabase,
                useFactory: function (firebaseApp) { return firebaseApp.database(); },
                deps: [FirebaseApp]
            }
        ].concat(additionalApps.map(function (config) { return ({
            provide: config.token,
            useFactory: function (injector) { return new FirebaseApp(config, injector); },
            deps: [Injector]
        }); }));
    };
    FirebaseModule.decorators = [
        { type: NgModule, args: [{},] },
    ];
    /** @nocollapse */
    FirebaseModule.ctorParameters = [];
    return FirebaseModule;
}());
//# sourceMappingURL=firebase.module.js.map